/*#################################################################################################
##  |\   ======   /|  ##     Copyright (C) 2013-2014  Maurizio Sartori     ##  |\   ======   /|  ##
##  |__\========/__|  ##  ===============================================  ##  |__\========/__|  ##
##  |\            /|  ##     Written by:  Maurizio Sartori                 ##  |\            /|  ##
##  |  \        /  |  ##     e-mail:      masar@MasarLabs.com              ##  |  \        /  |  ##
##  |    \    /    |  ##     Site:        http://www.masarlabs.com         ##  |    \    /    |  ##
##  |    /=\/=\    |  ##  ===============================================  ##  |    /=\/=\    |  ##
##  |  /========\  |  ##     License GPLv3+: GNU GPL version 3 or later    ##  |  /========\  |  ##
##  |/   ======   \|  ##          http://gnu.org/licenses/gpl.html         ##  |/   ======   \|  ##
###################################################################################################
## $Id: cap.c 4108 2014-02-06 17:10:52Z masar@masar $
#################################################################################################*/

static char Psz_SvnId[] __attribute__ ((unused)) =
    "$Id: cap.c 4108 2014-02-06 17:10:52Z masar@masar $";

#include "cap.h"

#include <sys/capability.h>
#include <unistd.h>

//************************************************************************************************/
//* Data
//************************************************************************************************/

/*************************************************************************************************/
/** getCapabilities.
*** Returns -1 on error.
**************************************************************************************************/
int getCapabilities (void)
   {
   const cap_value_t capValues[1] = { CAP_NET_RAW };

   cap_t capOn = cap_init();
   cap_set_flag(capOn, CAP_PERMITTED, 1, capValues, CAP_SET);
   cap_set_flag(capOn, CAP_EFFECTIVE, 1, capValues, CAP_SET);
   int iRc = cap_set_proc(capOn);
   cap_free(capOn);

   return iRc;
   }

/*************************************************************************************************/
/** dropCapabilities.
*** Returns -1 on error.
**************************************************************************************************/
int dropCapabilities (void)
   {
   if ((setgid(getgid()) < 0) || (setuid(getuid()) < 0)) {
      return -1;
      }

   cap_t capNone = cap_init();
   int iRc = cap_set_proc(capNone);
   cap_free(capNone);

   return iRc;
   }

/*************************************************************************************************/
/*************************************************************************************************/
