/*#################################################################################################
##  |\   ======   /|  ##     Copyright (C) 2013-2014  Maurizio Sartori     ##  |\   ======   /|  ##
##  |__\========/__|  ##  ===============================================  ##  |__\========/__|  ##
##  |\            /|  ##     Written by:  Maurizio Sartori                 ##  |\            /|  ##
##  |  \        /  |  ##     e-mail:      masar@MasarLabs.com              ##  |  \        /  |  ##
##  |    \    /    |  ##     Site:        http://www.masarlabs.com         ##  |    \    /    |  ##
##  |    /=\/=\    |  ##  ===============================================  ##  |    /=\/=\    |  ##
##  |  /========\  |  ##     License GPLv3+: GNU GPL version 3 or later    ##  |  /========\  |  ##
##  |/   ======   \|  ##          http://gnu.org/licenses/gpl.html         ##  |/   ======   \|  ##
###################################################################################################
## $Id: util.h 4158 2014-02-18 15:21:44Z masar@masar $
#################################################################################################*/

#ifndef PATD_UTIL_H
#define PATD_UTIL_H 1

#include <signal.h>
#include <unistd.h>

/*************************************************************************************************/
/** Global Variables
**************************************************************************************************/
extern volatile sig_atomic_t sig_SignalFlag;

/*************************************************************************************************/
/** Global Macros
**************************************************************************************************/

/*************************************************************************************************/
/** Global Functions
**************************************************************************************************/
int setSignal (int iSignal, __sighandler_t pfnFunction);
void signalHandlerIncrement (int iSignal);

long tsCompare (const struct timespec * pTime1, const struct timespec * pTime2);
void tsDelta (const struct timespec * pTime1, const struct timespec * pTime2,
              struct timespec * pResult);
void tsAdd (const struct timespec * pTime1, const struct timespec * pTime2,
            struct timespec * pResult);

const char const * hexDump (const void * pData, ssize_t iLen, ssize_t * piOffset);

int writePidfile (const char * pFilename);

#endif
/*************************************************************************************************/
/*************************************************************************************************/
